//
//  BehaviorChainManager.h
//  VVSliders
//
//  Created by bagheera on 2/8/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <VVBasics/VVBasics.h>
#import "FXChainManager.h"
@class FXChainManager;
#import "BehaviorFXChain.h"
@class BehaviorFXChain;
#import "BehaviorChainWindow.h"
@class BehaviorChainWindow;
#import "BehaviorChainListController.h"
@class BehaviorChainListController;
#import "BehaviorCreationController.h"
@class BehaviorCreationController;




@interface BehaviorChainManager : FXChainManager <VVSnapshotProtocol> {
	MutLockArray				*windArray;			//	array containing BehaviorChainWindow instances
	BOOL							frick;
	BOOL							frack;
	BOOL							frock;
	NSDictionary					*behaviorDict;
	id								mainWindow;	//	for convenience, this is the (only) behavior chain window.  this is the *actual window*, not the windowController
}

//	this method is called whenever a chain is added or removed, and sends a notification that any chain list views must be updated
//	this method has no worthwhile implementation in VVFXChainManager, because VVFXChainManager is a superclass
//	the subclasses of VVFXChainManager that represent each type of chain over-ride this method to post notifications
- (void) updateChainBasedLists;
- (IBAction) openANewWindow:(id)sender;

- (id) returnNewEffectNamed:(NSString *)name;

//	this method returns an array of NSMenuItems.  used for populating contextual menus.
- (NSMutableArray *) getBehaviorChainMenuItemArray;
- (BehaviorFXChain *) findBehaviorChainNamed:(NSString *)chainName;

- (void) resetChainEvalFlags;

//	this method remove a BehaviorChainWindow from the windArray.  it also closes and frees the window.
- (void) removeBehaviorChainWindow:(id)sender;
//	this method is called whenever a window is added or removed.  it goes through the windows in the windArray, and changes their windowTitles.
- (void) updateWindowNames;

- (void) readyToUse;		//	means that reg. passed, i can write files to disk

- (void) displayChainNamed:(NSString *)n;

- (void) writeThisFXChainDictToDisk:(NSMutableDictionary *)d;
- (void) saveFXChainsToDisk;
- (void) loadFXChainsFromDisk;

- (NSMutableArray *) createSnapshot;
- (void) loadSnapshot:(NSMutableArray *)s;

@property (readonly) MutLockArray *windArray;
@property (readonly) NSDictionary *behaviorDict;
@property (readonly) id mainWindow;

@end
