//
//  CIColorElement.h
//  VDMX
//
//  Created by bagheera on 8/8/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVSliderControl.h"
#import "VVButton.h"
#import "VVColorUI.h"
@class VVColorUI;


@protocol CIColorElementDelegateProtocol
	- (void) VVColorElementChanged:(id)sender;
@end


@interface CIColorElement : NSBox <VVSnapshotProtocol> {
	VVSliderControl		*rSlider;
	VVSliderControl		*gSlider;
	VVSliderControl		*bSlider;
	
	VVColorUI			*colorView;
	VVButton			*sampleButton;
	
	id					target;
	SEL					action;
	
	BOOL				deleted;
	id					delegate;
	
	NSRect				lastRenderedFrame;
	NSString			*key;
}

- (id) initWithFrame:(NSRect)newFrame;
- (id) initWithFrame:(NSRect)newFrame canvasSize:(NSSize)newCanvasSize;
- (void) prepareToBeDeleted;

- (void) pushColorToTarget:(id)sender;

- (void) setTarget:(id)newTarget;
- (void) setAction:(SEL)newAction;

- (void) mouseDown:(NSEvent *)e;

- (void) sliderUsed:(id)sender;
- (void) sampleButtonUsed:(id)sender;
- (void) clickedOnAColorNotification:(NSNotification *)note;
- (void) contextualColorHolderChosen:(NSArray *)pathArray;	//	called by the VVColorUI class (i'm it's delegate) when user right-clicks on a color holder

- (void) repositionElements;
- (void) bang;

- (void) setColorWithRed:(float)r green:(float)g blue:(float)b;
- (void) setColorFromCIColor:(CIColor *)p;
- (CIColor *) returnCIColor;

@property (assign, readwrite) id delegate;

//	I'm the delegate for a bunch of sliders and buttons..
- (void) VVSliderInterestingPointsChanged:(id)sender;
- (void) VVSliderSyncFlagChanged:(id)sender;
- (void) VVSliderBehavFlagChanged:(id)sender;
- (void) VVSliderMaxEnvChanged:(id)sender;
- (void) VVSliderMinEnvChanged:(id)sender;
- (void) VVButtonSyncFlagChanged:(id)sender;
- (void) VVButtonThreshValChanged:(id)sender;
- (void) paramSnapUpdated:(id)sender;

//	all CI & QC elements respond to this method, and return their "name" (the name of the attribute in the CI or QC patch)
@property (assign, readwrite) NSString *key;

@end
