//
//  CIPositionElement.h
//  VVSliders
//
//  Created by bagheera on 2/16/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVPositionUI.h"
@class VVPositionUI;
#import "VVSnapshotProtocol.h"
#import "VVSliderControl.h"




@protocol CIPositionElementDelegateProtocol
	- (void) VVPositionElementChanged:(id)sender;
@end


@interface CIPositionElement : NSBox <VVSnapshotProtocol> {
	BOOL				deleted;
	id					delegate;
	VVSliderControl		*xSlider;
	VVSliderControl		*ySlider;
	VVPositionUI		*posn;
	NSPoint				outputPoint;
	NSSize				canvasSize;
	id					target;
	SEL					action;
	NSRect				lastRenderedFrame;
	
	NSString			*key;
}

- (id) initWithFrame:(NSRect)newFrame canvasSize:(NSSize)newCanvasSize;
- (void) prepareToBeDeleted;

- (void) setTarget:(id)newTarget;
- (void) setAction:(SEL)newAction;
- (void) sliderUsed:(id)sender;
- (void) posnControlUsed:(id)sender;
- (void) updateOutputPoint;
- (void) bang;

- (void) setCanvasSize:(NSSize)newSize;

@property (assign, readwrite) NSPoint pointValue;
- (CIVector *) returnCIVector;
- (CIVector *) returnFlippedCIVector;

- (void) contextualPointHolderChosen:(NSArray *) pathArray;	//	called by VVPositionUI class (i'm it's delegate) when i pick a new position data source from the contextual menu

//	I'm the delegate for a bunch of sliders and buttons..
- (void) VVSliderInterestingPointsChanged:(id)sender;
- (void) VVSliderSyncFlagChanged:(id)sender;
- (void) VVSliderBehavFlagChanged:(id)sender;
- (void) VVSliderMaxEnvChanged:(id)sender;
- (void) VVSliderMinEnvChanged:(id)sender;
- (void) VVButtonSyncFlagChanged:(id)sender;
- (void) VVButtonThreshValChanged:(id)sender;

- (void) paramSnapUpdated:(id)sender;
@property (assign, readwrite) id delegate;

//	all CI & QC elements respond to this method, and return their "name" (the name of the attribute in the CI or QC patch)
@property (assign, readwrite) NSString *key;


@end
