//
//  CIRectangleElement.h
//  VVSliders
//
//  Created by bagheera on 3/14/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import "VVSliderControl.h"
//@class VVSliderControl;
//#import <VVEssentials/VVEssentials.h>
#import "VVRectangleUI.h"
@class VVRectangleUI;
//#import "GlobalKeys.h"
#import "VVSnapshotProtocol.h"
#import "VVSliderControl.h"


@interface CIRectangleElement : NSBox <VVSnapshotProtocol> {
	VVSliderControl			*xSlider;
	VVSliderControl			*ySlider;
	VVSliderControl			*widthSlider;
	VVSliderControl			*heightSlider;
	VVRectangleUI			*rectUI;
	NSRect					outputRect;
	NSSize					canvasSize;
	id						target;
	SEL						action;
	NSRect					lastRenderedFrame;
	id						delegate;
	BOOL					deleted;
	NSString				*key;
}

- (id) initWithFrame:(NSRect)newFrame;
- (id) initWithFrame:(NSRect)newFrame canvasSize:(NSSize)newCanvasSize;
- (void) prepareToBeDeleted;

- (void) rectControlUsed:(id)sender;
- (void) xSliderUsed:(id)sender;
- (void) ySliderUsed:(id)sender;
- (void) widthSliderUsed:(id)sender;
- (void) heightSliderUsed:(id)sender;
- (void) updateOutputRect;
- (void) bang;

- (void) setCanvasSize:(NSSize)newSize;

- (void) setTarget:(id)newTarget;
- (void) setAction:(SEL)newAction;

@property (readonly) NSRect outputRect;

- (void) setStateFromRect:(NSRect)rect;

- (CIVector *) returnCIVector;
- (CIVector *) returnFlippedCIVector;

- (NSRect) returnSizedRect;

@property (readonly) VVSliderControl *xSlider;
@property (readonly) VVSliderControl *ySlider;
@property (readonly) VVSliderControl *widthSlider;
@property (readonly) VVSliderControl *heightSlider;

//	I'm the delegate for a bunch of sliders and buttons..
- (void) VVSliderInterestingPointsChanged:(id)sender;
- (void) VVSliderSyncFlagChanged:(id)sender;
- (void) VVSliderBehavFlagChanged:(id)sender;
- (void) VVSliderMaxEnvChanged:(id)sender;
- (void) VVSliderMinEnvChanged:(id)sender;

- (void) paramSnapUpdated:(id)sender;
@property (assign, readwrite) id delegate;

//	all CI & QC elements respond to this method, and return their "name" (the name of the attribute in the CI or QC patch)
@property (assign, readwrite) NSString *key;


@end
