//
//  CITapElement.h
//  VVSliders
//
//  Created by bagheera on 4/16/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CoreVideo/CoreVideo.h>
#import "VVRTap.h"
#import "VVRTapMenuController.h"
#import "VVNSPopUpButton.h"
#import "VVSnapshotProtocol.h"




@interface CITapElement : NSBox <VVSnapshotProtocol> {
	VVNSPopUpButton				*button;
	VVRTap						*rTap;
	VVRTapMenuController		*menuController;
	id							myTarget;
	SEL							myAction;
	NSString					*key;
}

- (void) prepareToBeDeleted;

- (void) startPresetRestoreNotification:(NSNotification *)note;
- (void) stopPresetRestoreNotification:(NSNotification *)note;

- (void) tapSourceChanged;

- (CVOpenGLTextureRef) getTexture;
- (BOOL) questionableColors;

//	these don't do anything, but having them in this class reduces warnings...
- (void) setTarget:(id)newTarget;
- (void) setAction:(SEL)newAction;
- (VVRTapMenuController *) menuController;
- (VVRTap *) rTap;

//	all CI & QC elements respond to this method, and return their "name" (the name of the attribute in the CI or QC patch)
@property (assign, readwrite) NSString *key;

@end
