


@protocol CompositorProtocol


- (void) lockForRender;
- (BOOL) tryLockForRender;
- (void) unlockRender;
- (void) drawContent;

- (NSMutableArray *) layerArray;
- (IBAction) deleteSelectedLayers:(id)sender;

- (void) moveTheseLayers:(NSMutableArray *)srcArray toIndex:(int)index ofLayer:(id)dstLayer;

- (long) getUniqueID;
- (void) uniqueIDRecovered:(long)p;

- (id) findLayerByName:(NSString *)n;

- (void) registerNewPreviewWindow:(id)n;
- (void) removeRegisteredPreviewWindow:(id)n;

- (NSMutableDictionary *) fontSynthPathsDict;
- (NSMenu *) fontSynthNamesMenu;

@property (readonly) id fullscreenToggle;
@property (readonly) id mainView;
@property (readonly) NSPopUpButtonCell *compTypeMenuCell;
@property (readonly) NSMutableArray *compFilterHumanNameArray;
@property (readonly) NSMutableArray *compFilterNameArray;
@property (readonly) id appController;
@property (readonly) id chainManager;

@property (readonly) NSMutableDictionary *imageSourcesPathsDict;
@property (readonly) id tapManager;
@property (readonly) NSMenu *imageSourcesNamesMenu;

- (void) refreshQCFXLists;

@property (readonly) NSImage *layerTabVideoInputImage;
@property (readonly) NSImage *layerTabTapImage;
@property (readonly) NSImage *recordingFileImage;
@property (readonly) id recordToggleButton;


@end






@protocol CompositorGLViewProtocol


@property (readonly) NSSize canvasSize;
@property (readonly) NSOpenGLContext *sharedContext;
@property (readonly) CVOpenGLTextureCacheRef textureCache;
@property (readwrite) BOOL fullscreen;
@property (readonly) BOOL willFullscreenHideAModal;


@end





