//
//  FXChain.h
//  VVSliders
//
//  Created by bagheera on 2/8/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "FXChainManager.h"
@class FXChainManager;
@class FXObject;




@interface FXChain : NSObject {
	BOOL				deleted;
	IBOutlet NSBox		*backgroundBox;
	IBOutlet NSView		*myView;
	
	NSString			*chainName;
	NSMutableArray		*fxArray;
	FXChainManager		*chainManager;
	
	NSScrollView		*parentScrollView;
}

- (id) initWithParentManager:(FXChainManager *)newManager andScrollView:(NSScrollView *)newScrollView;

- (void) windowDidLoad;
- (void) prepareToBeDeleted;

- (NSMutableArray *) createSnapshot;
- (void) loadSnapshot:(NSArray *)snap;

- (void) resizeChain;
- (void) setFXPositions;
- (void) updateMyView;

- (id) returnNewEffectNamed:(NSString *)name;
- (IBAction) loadEffectNamed:(NSString *)name;
- (void) addEffectObject:(id)theObject;
- (void) insertEffectObject:(id)theObject intoChainAtIndex:(unsigned int)theIndex;
- (void) insertEffectData:(NSData *)theData intoChainAtIndex:(unsigned int)theIndex;
- (void) deleteThisEffect:(FXObject *)del;
- (void) deleteEffectNamed:(NSString *)n;
- (void) deleteAllEffects;
- (void) removeEffectFromChain:(id)theObject;
- (FXObject *) fromEndFindEffectNamed:(NSString *)s;

//	this method passes a passed pointer (to whatever) through each successive item in the chain
- (void) passPtrThruChain:(id) passed;

//	these methods exist so the drag dest box works with layerfxchains
- (void) lockForRender;
- (void) unlockRender;

@property (assign, readwrite) NSString *chainName;
@property (readonly) id myView;
@property (readonly) id backgroundBox;
@property (assign, readwrite) NSScrollView *parentScrollView;
@property (readonly) FXChainManager *chainManager;
@property (readonly) NSMutableArray *fxArray;

@end
