//
//  FXObject.h
//  NewFXTestApp
//
//  Created by bagheera on 12/8/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "FXChainManager.h"
@class FXChainManager;




@interface FXObject : NSObject <NSCoding, VVSnapshotProtocol>
{
	NSString			*myName;		//	my name- used to load the .nib
	FXChain			*myChain;
	FXChainManager	*myChainManager;
	NSRect			localFrame;		//	my frame in the fxchain window- makes drag and drop easier
	NSRect			expandedFrame;	//	my frame when expanded
	id				myPanel;		//	my NSView subclass (FXObjectView) with the controls and shizzle on it
	BOOL				bypass;
	BOOL				collapsed;
	BOOL				deleted;
}

// initializes an instance of FXObject, loading the .nib from the passed name
- (id) initWithName:(NSString *)newName;
//	tells my chain to delete me (should release me)
- (void) tellMyChainToDeleteMe;
//	called by the chain just prior to deleting me...
- (void) prepareToBeDeleted;

//	this method gets overridden by subclasses to deal with whatever ptr this object is getting passed
- (void) processPassedPtr:(id) passedPtr;

//- (void) setLocalFrame:(NSRect)newFrame;
- (void) resizeFXWidth:(int)newWidth;
- (void) reposFXOrigin:(NSPoint)newOrigin;
- (void) fxResizingHeight:(int)newHeight;
- (void) forceRedraw;

- (void) expand;
- (void) collapse;
- (BOOL) collapsed;

- (void) bypassToggleUsed:(id)sender;
- (BOOL) bypass;

- (BOOL) deleted;

@property (readonly) NSRect localFrame;
@property (readonly) id myPanel;
@property (assign, readwrite) NSString *myName;
@property (assign, readwrite) FXChain *myChain;
@property (assign, readwrite) FXChainManager *myChainManager;
@property (readonly) NSRect expandedFrame;
@property (readonly) NSString *className;

//	these methods ensure that VVFXObject complies with the NSCoding protocol
- (id) initWithCoder:(NSCoder *)coder;
- (void) encodeWithCoder:(NSCoder *)coder;

@end
