//
//  QCAttributePublisher.h
//  VDMX
//
//  Created by David Lublin on 1/11/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

//	this object bridges a QCRenderer and the VDMX DSC

#import <Cocoa/Cocoa.h>
#import "VVQCSTap.h"
#import "DataSourceController.h"



@interface QCAttributePublisher : NSObject {
	NSString				*publisherCatName;			//	the main category publisherCatName
	NSMutableDictionary		*dataSourcesDict;	//	dict that contains the data sources i'm publishing at their keys
	NSMutableDictionary		*dscStorageDict;
	
	NSMutableArray			*tapArray;
	
	id						composition;
	id						renderer;				//	this could be a QCView or a QCSource
	id						dataSourceController;
	
	id						delegate;				//	I'm going to tell this whenever the DSC queries me	
	
	BOOL					deleted;
}

- (void) prepareToBeDeleted;
//	loading, unloading, and pushing from the renderer to the storage dict
- (void) publishAttributesForComposition:(id)newComp;
- (void) removeAllPublishedSources;
- (void) pushRendererValsToStorage;
- (void) pushRendererImagesToTaps;
- (void) publishValsForRenderer:(QCRenderer *)n;
//	data source methods
- (void) setDataSourceWithVal:(DataSource *)ds;
- (float) rValForColorHolder:(DSColorHolder *)holder;
- (float) gValForColorHolder:(DSColorHolder *)holder;
- (float) bValForColorHolder:(DSColorHolder *)holder;
- (float) xValForPointHolder:(DSPointHolder *)holder;
- (float) yValForPointHolder:(DSPointHolder *)holder;

//	key value
- (NSMutableArray *) tapArray;
- (NSString *) publisherCatName;
- (void) setPublisherCatName:(NSString *)n;
- (void) setDataSourceController:(id)n;
- (void) setRenderer:(id)newVal;
- (void) setDelegate:(id)n;

@end
