//
//  TheApplication.h
//  VDMX
//
//  Created by bagheera on 10/2/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
#import <Quartz/Quartz.h>



NSMutableArray		*qcDeleteArray;
pthread_mutex_t		qcDeleteLock;
NSMutableArray		*bitmapDeleteArray;		//	array of dicts
pthread_mutex_t		bitmapDeleteLock;




@interface TheApplication : NSApplication {
	ATSFontContainerRef				*loadedFontContainerRef;
	NSMutableDictionary				*winColorDict;
	NSMutableDictionary				*tableColorDict;
	NSMutableDictionary				*labelColorDict;
	NSMutableDictionary				*levelViewColorDict;
	NSMutableDictionary				*popUpColorDict;
	NSMutableDictionary				*bezierColorDict;
	NSMutableDictionary				*fxColorDict;
	NSMutableDictionary				*pluginColorDict;
	NSMutableDictionary				*buttonColorDict;
	NSMutableDictionary				*sliderColorDict;
}


+ (void) addItemToQCDeleteArray:(id)n;
+ (void) purgeQCDeleteArray;
+ (void) addItemToBufferDeleteArray:(id)n;
+ (void) purgeBufferDeleteArray;

+ (NSString *) pathToFolderNamed:(NSString *)f;
+ (NSString *) pathToCustomUserFolder;
+ (NSString *) pathToSubResourcesFolderNamed:(NSString *)f;

+ (NSOpenGLPixelFormat *) defaultPixelFormat;

@property (readonly) BOOL acceptsFirstResponder;
@property (readonly) BOOL becomeFirstResponder;
- (void) loadFonts;

@property (assign, readwrite) NSMutableDictionary *winColorDict;
@property (assign, readwrite) NSMutableDictionary *tableColorDict;
@property (assign, readwrite) NSMutableDictionary *labelColorDict;
@property (assign, readwrite) NSMutableDictionary *levelViewColorDict;
@property (assign, readwrite) NSMutableDictionary *popUpColorDict;
@property (assign, readwrite) NSMutableDictionary *bezierColorDict;
@property (assign, readwrite) NSMutableDictionary *fxColorDict;
@property (assign, readwrite) NSMutableDictionary *pluginColorDict;
@property (assign, readwrite) NSMutableDictionary *buttonColorDict;
@property (assign, readwrite) NSMutableDictionary *sliderColorDict;

@end
