//
//  VVCIGLAttrContext.h
//  VDMX
//
//  Created by bagheera on 7/15/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVCIGLContext.h"
#import "QCCIUIObjects.h"
#import "CIAttributeLoader.h"




@interface VVCIGLAttrContext : VVCIGLContext <VVSnapshotProtocol> {
	id						attributeLoader;
	pthread_rwlock_t		renderLock;
	CIFilter				*filter;
}


+ (id) createWithContext:(NSOpenGLContext *)c textureCache:(CVOpenGLTextureCacheRef)tc sized:(NSSize)s forFilterNamed:(NSString *)n;
- (id) initWithContext:(NSOpenGLContext *)c textureCache:(CVOpenGLTextureCacheRef)tc sized:(NSSize)s forFilterNamed:(NSString *)n;

- (BOOL) hasAttributes;

//	this method exists so subclasses of me can make a different-class attribute loader quickly and easily without writing extra code
- (id) createAttributeLoader;

- (NSMutableDictionary *) createSnapshot;
- (void) loadSnapshot:(NSDictionary *)d;
- (void) deprecatedLoadSnapshot:(NSDictionary *)d;

- (void) useFilterNamed:(NSString *)n;
- (void) removeAllExistingElements;

- (id) attributeLoader;
- (void) setParentScrollView:(id)n;


@end
