//
//  VVFile.h
//  VVSliders
//
//  Created by bagheera on 11/18/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import <VVEssentials/VVEssentials.h>
#import "GlobalKeys.h"




//	internal file type tags
#define VVNoFileType			-1
#define VVQTFileType			0
#define VVQCFileType			1
#define VVTapFileType			2
#define VVTextFileType			3
#define VVURLFileType			4
#define VVFlashFileType			5
#define VVImageFileType			6




@interface VVFile : NSObject {
	//	ptrs to useful places
	id				compositor;

	//	info about this vvfile that is stored with a snapshot
	int					vvFileType;			//	which handler to use
	long				uniqueFileId;		//	unique ID assigned on creation
	NSString			*name;				//	display name for this vvfile
	
	//	info about the vvfile that is set on load / during performance
	NSImage				*posterImage;		//	display image for this vvfile
	id					parent;				//	the vvfolder (or vvpage) that contains this vvfile
	id					currentSource;		//	the layer that is currently accessing this vvfile
	BOOL				validFile;			//	whether or not this vvfile can be triggered
	BOOL				fileIsMissing;		//	if this vvfile is temporarily unavailable
	
	//	general dict for storing info about this vvfile
	NSMutableDictionary		*movieProps;		//	movie properties that were extracted from the actual movie file
	
	//	for disk based files.. declared here for standardization
	BOOL				fileIsAlias;		//	whether or not the file loaded was an alias
	NSString			*fullPath;			//	this is the resolved path (can NOT be an alias)
	NSString			*relPath;			//	string for path to file with the same name in the media folder
	NSString			*originalPath;		//	this is the path that the file was originally loaded from.. it might be an alias
	NSString			*fileType;			//	the filetype of the file on disk
	
	//BOOL					qtFlag;
	//BOOL					qcFlag;
	//VVQTMovie			*movieFile;				//	this is the version accessed by the MovieSource and edited by the MediaInspector
	//VVQTMovie			*originalMovieFile;		//	this is the copy accessed by the Media Inspector for preview
	
	//	for shortcuts- populated on creation (i can find the midi notification center thru compositor), updated when layers are created
	//NSMutableDictionary		*shortcutsByLayerName;
	
	//QTVisualContextRef		visualContext;
	
	//NSMutableArray		*warpMarkers;
	//QTVisualContextRef	visualContext;
}

- (NSString *) description;

+ (id) createWithCompositor:(id)newCompsitor;
+ (id) createWithName:(NSString *)newName andCompositor:(id)newCompositor;
//+ (id) createWithParent:(VVFolder *)newParent andName:(NSString *)newName andQTFlag:(BOOL)newFlag andCompositor:(id)newCompositor;
//+ (id) createWithParent:(VVFolder *)newParent andName:(NSString *)newName andQCFlag:(BOOL)newFlag andCompositor:(id)newCompositor;
//+ (id) createQTWithPath:(NSString *)newPath andName:(NSString *)newName andQTMovie:(VVQTMovie *)newMovie andCompositor:(id)newCompositor;
//+ (id) createWithPath:(NSString *)newPath andName:(NSString *)newName andQTFlag:(BOOL)newFlag andCompositor:(id)newCompositor;
//+ (id) createWithPath:(NSString *)newPath andName:(NSString *)newName andQCFlag:(BOOL)newFlag andCompositor:(id)newCompositor;
//+ (id) createWithParent:(VVFolder *)newParent andCompositor:(id)newCompositor;

- (id) initWithCompositor:(id)newCompositor;
- (id) initWithName:(NSString *)newName andCompositor:(id)newCompositor;
//- (id) initWithParent:(VVFolder *)newParent andName:(NSString *)newName andQTFlag:(BOOL)newFlag andCompositor:(id)newCompositor;
//- (id) initWithParent:(VVFolder *)newParent andName:(NSString *)newName andQCFlag:(BOOL)newFlag andCompositor:(id)newCompositor;
//- (id) initQTWithPath:(NSString *)newPath andName:(NSString *)newName andQTMovie:(VVQTMovie *)newMovie andCompositor:(id)newCompositor;
//- (id) initWithPath:(NSString *)newPath andName:(NSString *)newName andQTFlag:(BOOL)newFlag andCompositor:(id)newCompositor;
//- (id) initWithPath:(NSString *)newPath andName:(NSString *)newName andQCFlag:(BOOL)newFlag andCompositor:(id)newCompositor;

- (NSMutableDictionary *) returnSnapshot;
- (NSMutableDictionary *) createSnapshot;
- (BOOL) loadFromSnapshot:(NSDictionary *)snap withCompositor:(id)comp;
- (NSString *) createRelPath;
- (NSString *)resolveAliasFilePath:(NSString *)path:(BOOL)isAliasVar;
- (NSString *)justResolveAliasFilePath:(NSString *)path;
- (void) initNonQTFile;

- (NSString *) name;
- (void) setName:(NSString *) newName;
- (id) parent;
- (void) setParent:(id)newParent;
- (NSString *) fullPath;
- (NSString *) originalPath;
- (void) setFullPath:(NSString *)newFullPath;
- (id) currentSource;
- (void) setCurrentSource:(id)newSource;
- (NSImage *) posterImage;
- (NSMutableDictionary *) movieProps;
- (void) setMovieProps:(NSMutableDictionary *)newProps;
- (NSString *) fileType;
- (long) uniqueFileId;
- (void) setPosterImage:(NSImage *)newPosterFrame;
- (BOOL) validFile;
- (NSMutableDictionary *)movieProps;
- (int) vvFileType;
@end
