//
//  VVFileLoader.h
//  VDMX
//
//  Created by David Lublin on 10/17/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import <AGL/agl.h>
//#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>
#import "VVStatChecker.h"
#import "VVPlugin.h"
#import "VVFileLoaderQueueItem.h"
@class VVFileLoaderQueueItem;
#import "VVFile.h"
#import "VVFolder.h"
//@class VVFolder;
#import "VVQTMovie.h"
//@class VVQTMovie;
//#import "VVFile.h"
//@class VVFile;
#import "VVPage.h"
#import "VVQCFile.h"
//@class VVQCFile;
#import "VVQTFile.h"
//@class VVQTFile;
#import "VVTapFile.h"
//@class VVTapFile;
#import "VVTextFile.h"
//@class VVTextFile;
#import "VVURLFile.h"
//@class VVURLFile;
//@class VVPlugin;
//@class VVImageFile;
#import "VVImageFile.h"
//#import "MediaBinProtocols.h"
//#import "VVFlashThumbnailGenerator.h"
@class VVFlashThumbnailGenerator;

#import "VVPageController.h"
#import "VVFlashThumbnailGenerator.h";


@protocol FileLoaderDelegateProtocol
	- (void) setFileLoader:(id)sender;
@end


@interface VVFileLoader : NSObject {
	id					appController;
	
	NSMutableArray		*toBeLoadedArray;		//	The queue of files to load
	NSMutableArray		*filesToLoadNow;		//	The files to load the next time I load a batch of files
	int					chunkSize;				//	The max number of files that I can pass off to the loading thread at a time

	//	Variables for keeping track of the current loading process
	
	BOOL				loading;				//	Whether or not files are currently loading
	BOOL				cancelLoadingFlag;		//	Whether or not the file loading thread should abort
	int					filesLoaded;			//	The number of files loaded so far
	long				missingFilesCount;		//	The number of files that could not be loaded from snapshots during the load process
	
	pthread_mutex_t		loadingLock;
	
	//	This stuff is for loading with the open panel
	id					loadToMe;				//	The VVPage that the files will be added to, or nil
	int					loadIndex;				//	Where on the specified page should files be added
	BOOL				loadIndexFlag;			//	Whether the loadIndex is a grid index (includes blanks) or not
	
	//	I have a menu with a list of all the vvfolders
	NSDictionary		*fontAttribs;			
	NSMenu				*folderListMenu;
	NSMenu				*folderAndMediaBinListMenu;
	
	BOOL				autoRecordOverride;
	BOOL				loadingAutoRecording;
	
	NSMutableArray		*reconnectedFilesArray;
	NSMutableArray		*reconnectedSnapsArray;
	
	VVFlashThumbnailGenerator	*flashThumbGenerator;
	
	NSDate				*startLoadDate;			//	This NSDate is handy for measuring how long the entire file loading process takes
}

- (id) initWithAppController:(id)new;
//	Notifications are sent if things need to find the file loader
- (void) setFileLoaderForObjectNotificiation:(NSNotification *)note;
//	Open files with a loading panel
- (void) loadWithOpenPanel;
- (void) loadWithOpenPanelToFolder:(id)loadMe atIndex:(int)index isGridIndex:(BOOL)indexFlag;
- (void) loadWithOpenPanelToFolder:(id)loadMe atIndex:(int)index isGridIndex:(BOOL)indexFlag onWindow:(NSWindow *)window;
- (void) loadWithOpenPanelDidEnd:(NSOpenPanel *)sheet returnCode:(int)code contextInfo:(void *)contextInfo;
//	These are the methods for adding files to the loading queue
//	The file loader can load files from disk, can load snapshots of files, can make copies of files, or relink files
- (void) copyTheseFilesFromSnapshots:(NSArray *)snapsArray withParent:(id)parent atIndex:(int)index isGridIndex:(BOOL)indexFlag;
- (void) addTheseSnapshotsToQueue:(NSArray *)snapsArray withParent:(id)parent atIndex:(int)index isGridIndex:(BOOL)indexFlag;
- (void) addTheseFilesToQueue:(NSArray *)pathsArray withParent:(id)parent atIndex:(int)index isGridIndex:(BOOL)indexFlag;
- (void) relinkTheseSnapshots:(NSArray *)snapshots atPaths:(NSArray *)pathsArray;
//	These are the methods that actually do the file loading
- (void) loadNextBatchOfFiles;
- (void) threadedFileLoading;
- (void) finishedBatchOfFiles;
- (void) cancelFileLoading;
- (void) createThumbnailForURLFile:(id)n;
//	Key value
- (BOOL) loading;
- (long) missingFilesCount;
- (NSMutableArray *) toBeLoadedArray;
//	When files are done recording in the live input, this notification method is called
- (void) recordingDidStopNotification:(NSNotification *)note;
//	Varaibles for when files are auto-loaded after recording
- (BOOL) autoRecordOverride;
- (void) setAutoRecordOverride:(BOOL)val;
//	These are the methods for the menus that keep track of the list of available pages and media bins
- (void) updateFolderListNotificationReceived:(NSNotification *)note;
- (void) prepareFolderListMenu;
- (void) prepareFolderAndMediaBinListMenu;
- (void) addMediaBinsToMenu:(NSMenu *)addToMe;
- (void) addFolder:(id)folder toMenu:(NSMenu *)addToMe withDepth:(int)depth;
- (void) addPagesToMenu:(NSMenu *)addToMe withDepth:(int)depth;
- (NSMenu *) folderListMenu;
- (NSMenu *) folderAndMediaBinListMenu;
@end
