//
//  VVFileLoaderQueueItem.h
//  VDMX
//
//  Created by Jack Turner on 10/17/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface VVFileLoaderQueueItem : NSObject {
	NSString				*fullPath;
	long					parentUniqueID;
	int						index;
	BOOL					isRelinking;
	BOOL					isGridIndex;
	BOOL					isCopy;
	NSMutableDictionary		*fileSnapshot;		//	if the file being loaded has an associated snapshot, it's set here
}
+ (id) createWithRelinkingSnapshot:(NSMutableDictionary *)relinkSnap atFullPath:(NSString *)thePath;
+ (id) createWithSnapshot:(NSMutableDictionary *)newSnap andParentID:(long)parentID andIndex:(int)newIndex isGridIndex:(BOOL)indexFlag isCopy:(BOOL)copyFlag;
+ (id) createWithSnapshot:(NSMutableDictionary *)newSnap andParentID:(long)parentID andIndex:(int)newIndex isGridIndex:(BOOL)indexFlag;
+ (id) createWithPath:(NSString *)newPath andParentID:(long)parentID andIndex:(int)newIndex isGridIndex:(BOOL)indexFlag;
- (id) initWithRelinkingSnapshot:(NSMutableDictionary *)relinkSnap atFullPath:(NSString *)thePath;
- (id) initWithSnapshot:(NSMutableDictionary *)newSnap andParentID:(long)parentID andIndex:(int)newIndex isGridIndex:(BOOL)indexFlag isCopy:(BOOL)copyFlag;
- (id) initWithPath:(NSString *)newPath andParentID:(long)parentID andIndex:(int)newIndex isGridIndex:(BOOL)indexFlag;
- (NSString *) fullPath;
- (long) parentUniqueID;
- (int) index;
- (BOOL) isRelinking;
- (BOOL) isGridIndex;
- (BOOL) isCopy;
- (void) setFileSnapshot:(NSMutableDictionary *)newSnap;
- (NSMutableDictionary *) fileSnapshot;
@end
