//
//  VVFlashThumbnailGenerator.h
//  VDMX
//
//  Created by David Lublin on 7/31/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import <VVEssentials/VVEssentials.h>
#import "VVFileLoader.h"
#import "VVWebView.h"
@class VVWebView;


@interface VVFlashThumbnailGenerator : NSObject {
	//	the actual webview
	NSWindow			*renderWindow;
	VVWebView			*renderView;
	//	this is really just going to store the unique id's of the file
	NSMutableArray		*fileQueue;
	
	long				currentFileID;
	
	pthread_mutex_t		queueLock;
	BOOL				loading;
	
	id					appController;
	
	NSTimer				*timeOutTimer;
	BOOL				receivedAtLeastSomeData;
}
- (void)webView:(WebView *)sender didStartProvisionalLoadForFrame:(WebFrame *)frame;
- (void)webView:(WebView *)sender didFinishLoadForFrame:(WebFrame *)frame;
- (void)webView:(WebView *)sender didFailLoadWithError:(NSError *)error forFrame:(WebFrame *)frame;

//- (WebView *)webView:(WebView *)sender createWebViewWithRequest:(NSURLRequest *)request;
- (void)webView:(WebView *)sender resource:(id)identifier didReceiveAuthenticationChallenge:(NSURLAuthenticationChallenge *)challenge fromDataSource:(WebDataSource *)dataSource;

- (void) prepareRendererIfNeeded;
- (void) closeRenderer;
- (void) addFileIDToQueue:(long)fileID;
- (void) addFileToQueue:(VVURLFile *)n;
- (void) createThumbnailForNextFile;
- (void) webViewLoadTimedOut:(NSTimer *)t;
- (void) webView:(WebView *)sender didFinishLoadForFrame:(WebFrame *)frame;
- (void) setThumbnailForCurrentFile;
- (void) finishedGeneratingThumbnail;
- (void) lock;
- (void) unlock;
- (void) setAppController:(id)n;
- (void) progressUpdated:(NSNotification *)note;
@end
