//
//  VVFolder.h
//  VVSliders
//
//  Created by bagheera on 11/18/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVFile.h"



@interface VVFolder : NSObject <NSCoding> {
	long			uniqueFileId;
	
	NSString			*name;
	NSMutableArray	*contents;
	id				parent;
	NSString			*fullPath;
	int				cellsAcross;
	int				cellsDown;
	NSMutableArray	*gridLayout;
	id				compositor;
	//	for shortcuts
	//NSMutableDictionary		*shortcutsByLayerName;
}

- (NSString *) description;

+ (id) createWithPath:(NSString *)newPath andCompositor:(id)newCompositor;
+ (id) createWithPath:(NSString *)newPath andCompositor:(id)newCompositor andCellsAcross:(int)newCellsAcross;
+ (id) createWithParent:(VVFolder *)newParent andCompositor:(id)comp;
+ (id) createWithParent:(VVFolder *)newParent andName:(NSString *)newName andCompositor:(id)comp;
- (id) initWithPath:(NSString *)newPath andCompositor:(id)newCompositor;
- (id) initWithPath:(NSString *)newPath andCompositor:(id)newCompositor andCellsAcross:(int)newCellsAcross;
- (id) initWithParent:(VVFolder *)newParent andCompositor:(id)comp;
- (id) initWithParent:(VVFolder *)newParent andName:(NSString *)newName andCompositor:(id)comp;
- (id) initWithCompositor:(id)comp;

- (NSMutableDictionary *) returnSnapshot;
- (BOOL) loadFromSnapshot:(NSDictionary *)snap withCompositor:(id)comp;

//- (void) initMyShortcutsFromCompositor:(id)newCompositor;
//- (void) updateAllShortcutDictsToIncludeLayer:(Layer *)newLayer;

- (void) addObject:(id)anObject atIndex:(int)index;
- (void) addObjects:(NSArray *)objects atIndex:(int)index;
- (void) addObjects:(NSArray *)objects atGridIndex:(int)index;
- (void) theseObjectsWereMoved:(NSIndexSet *)indexes;
- (void) removeObjectsAtIndexes:(NSIndexSet *)indexes;
//- (void) removeObjectsAtGridIndexes:(NSIndexSet *)indexes;
- (void) clearContents;

- (id) findFileByUniqueFileId:(long)f;
- (id) findFolderByUniqueFileId:(long)f;
- (VVFolder *) findFolderWithName:(NSString *)searchName;

- (int) lastFilledGridIndex;
- (int) gridIndexOfObject:(id)theObject;
- (void) moveItems:(NSArray *)items atIndexes:(NSArray *)indexes inParents:(NSArray *)parents toIndex:(int)dropIndex;
- (BOOL) containsThisFolder:(VVFolder *)containsMe;
- (void) moveItems:(NSArray *)items atIndexes:(NSArray *)indexes inParents:(NSArray *)parents toGridIndex:(int)dropIndex;
- (int) getDropIndexAndRemoveItems:(NSArray *)items atIndexes:(NSArray *)indexes inParents:(NSArray *)parents forDropOnIndex:(int)dropIndex;

- (void) encodeWithCoder:(NSCoder *)coder;
- (id) initWithCoder:(NSCoder *)coder;

- (long) uniqueFileId;
- (NSString *) name;
- (void) setName:(NSString *)newName;
- (NSMutableArray *) contents;
- (id) parent;
- (void) setParent:(id)newParent;
- (NSString *) fullPath;
- (void) setFullPath:(NSString *)newFullPath;
- (int) cellsAcross;
- (void) setCellsAcross:(int)newDim;
- (int) cellsDown;
- (void) resetGridLayout;
- (NSMutableArray *) gridLayout;
- (id)compositor;
- (void) setCompositor:(id)newCompositor;
//- (NSMutableDictionary *) createRestoreState;
//- (void) restoreState:(NSMutableDictionary *) newState;
//- (NSMutableDictionary *) shortcutsByLayerName;
- (NSMutableArray *)missingFilesArray;
- (NSMutableArray *)availableFilesArray;

@end
