//
//  VVGLContext.h
//  VDMX
//
//  Created by bagheera on 2/13/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/CGLMacro.h>
#import <QuartzCore/QuartzCore.h>
//#import "GlobalKeys.h"




@interface VVGLContext : NSObject {
	NSOpenGLContext				*sharedContext;
	NSOpenGLPixelFormat			*customPixelFormat;
	NSOpenGLContext				*context;
	CVOpenGLBufferRef			pBufferRef;		//	NOT RETAINED- one pbuffer is shared between multiple contexts
	CVOpenGLTextureRef			textureRef;		//	this is the texture that i maintain in the shared context
	CVOpenGLTextureCacheRef		textureCacheRef;	//	NOT RETAINED- one cache is maintained
	CGColorSpaceRef				colorSpace;
	BOOL						initialized;
	BOOL						needsReshape;
	NSSize						size;
	BOOL						deleted;
}


+ (id) createWithContext:(NSOpenGLContext *)c textureCache:(CVOpenGLTextureCacheRef)tc sized:(NSSize)s;
- (id) initWithContext:(NSOpenGLContext *)c textureCache:(CVOpenGLTextureCacheRef)tc sized:(NSSize)s;

- (void) prepareToBeDeleted;

- (void) render;
- (void) draw;

- (void) setSize:(NSSize)n;

- (NSOpenGLPixelFormat *) customPixelFormat;
- (NSOpenGLContext *) context;
- (CVOpenGLBufferRef) pBufferRef;
- (void) setPBufferRef:(CVOpenGLBufferRef)n;
- (CVOpenGLTextureRef) textureRef;
- (BOOL) needsReshape;
- (void) setNeedsReshape:(BOOL)n;

@property (readonly) BOOL initialized;
@property (readonly) CGColorSpaceRef colorSpace;

@end
