//
//  VVImageFile.h
//  VDMX
//
//  Created by David Lublin on 6/18/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVFile.h"
@class VVFile;

#define VVImageFileUseBuiltInPlayer		0
#define VVIMageFileUseQTZPlayer			1
#define VVImageFileUseLastLayerPlayer	2


@interface VVImageFile : VVFile {
	NSBitmapImageRep		*imageRep;
	NSSize					originalSize;
	NSSize					actualSize;
}
+ (BOOL) isImageFileAtPath:(NSString *)p;
+ (NSBitmapImageRep *) imageRepAtPath:(NSString *)p;

+ (id) createWithCompositor:(id)c;
+ (id) createWithFilePath:(NSString *)p andCompositor:(id)c;

- (id) initWithCompositor:(id)c;
- (id) initWithFilePath:(NSString *)p andCompositor:(id)c;

- (BOOL) loadFromSnapshot:(NSMutableDictionary *)snap withCompositor:(id)comp;
- (BOOL) loadFromSnapshot:(NSMutableDictionary *)snap withFullPath:(NSString *)newPath andCompositor:(id)comp;

- (NSMutableDictionary *) convertPropsToDict;
- (void) convertDictToProps:(NSMutableDictionary *)dict;

- (void) initWithImage:(NSImage *)n;
- (void) setImageRep:(NSBitmapImageRep *)n;
- (NSBitmapImageRep *)imageRep;
- (NSSize) actualSize;
- (void) setActualSize:(NSSize)n;
- (NSSize) originalSize;
- (void) setOriginalSize:(NSSize)n;
- (int) useImageSource;

- (void) prepareImageCacheIfNeeded;

- (void) setMoviePropDefaults;
@end
