//
//  VVNSTabView.h
//  VDMX
//
//  Created by bagheera on 9/16/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
#import "DataSourceController.h"




@protocol VVNSTabViewDelegateProtocol
	- (void) tabViewElementChanged:(id)sender;
@end




@interface VVNSTabView : NSTabView <VVNSTabViewProtocol, VVSnapshotProtocol> {
	id					dataSourceController;
	NSMutableArray		*buttonArray;
	NSString			*key;
	
	id					target;
	SEL					action;
	BOOL				deleted;
}

- (NSMutableDictionary *) createSnapshot;
- (void) loadSnapshot:(NSDictionary *)dict;

- (void) createButtonsForTabs;
- (void) pushSelectedTabStateToButtons;
- (void) updateButtonPositions;
- (void) buttonUsed:(id)sender;
- (void) setDataSourceController:(id)thing;

- (int) selectedTabViewIndex;

- (void) setTarget:(id)n;
- (void) setAction:(SEL)n;
//	all CI & QC elements respond to this method, and return their "name" (the name of the attribute in the CI or QC patch)
- (NSString *) key;
- (void) setKey:(NSString *)n;

//- (id) delegate;
- (void) setDelegate:(id)n;

- (void) VVButtonSyncFlagChanged:(id)b;
- (void) VVButtonUIStateChanged:(id)b;
- (void) VVButtonThreshValChanged:(id)b;

- (void) paramSnapUpdated:(id)sender;

@end
