//
//  VVPage.h
//  VDMX
//
//  Created by David Lublin on 8/9/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>
//#import "Compositor.h"
//@class Compositor;
//#import "VVFile.h"
//#import "VVQTFile.h"
//#import "VVQCFile.h"
//#import "VVTapFile.h"
//#import "VVURLFile.h"
//#import "VVTextFile.h"
//#import "VVImageFile.h"
#import "VVSnapshotProtocol.h"


#import "VVFile.h"
#import "VVFolder.h"
#import "VVQCFile.h"
#import "VVQTFile.h"
#import "VVTapFile.h"
#import "VVTextFile.h"
#import "VVURLFile.h"
#import "VVImageFile.h"

#import "VVFileLoader.h"




@interface VVPage : NSObject <VVSnapshotProtocol> {
	long				uniqueFileId;
	NSString			*name;
	NSMutableArray	*contents;
	
	id				compositor;
	
	BOOL				wasFolder;
}


- (NSString *) description;
+ (id) createPageWithCompositor:(id)comp;
- (id) initPageWithCompositor:(id)comp;
- (void) prepareToBeDeleted;
- (void) loadFolderSnapshot:(NSDictionary *)snap;
- (void) copyPageFromSnapshot:(NSDictionary *)snap;
- (id) fileForUniqueId:(long)findMe;
- (void) addObjects:(NSArray *)objects atIndex:(int)index;
- (void) addTapFileNamed:(NSString *)tapName atIndex:(int)index;
- (void) addTextFileAtIndex:(int)index;
- (void) addURLFileAtIndex:(int)index;
- (void) removeObjectsAtIndexes:(NSIndexSet *)indexes;
- (void) removeObjectsAtIndexes:(NSIndexSet *)indexes andReplaceWithBlankSpaces:(BOOL)n;
- (void) closeGapAtIndex:(int)index;
- (void) removeEndFillerBlanks;
- (void) removeAllBlanks;
- (int) firstFileIndex;
- (NSMutableArray *) filesOnlyContents;
- (int) convertFilesOnlyIndexToContentsIndex:(int)filesOnlyIndex;
- (long) uniqueFileId;
- (NSString *) name;
- (void) setName:(NSString *) newName;
- (NSMutableArray *) contents;
- (NSArray *) missingFilesArray;
- (NSArray *) availableFilesArray;
- (int) lastFilledGridIndex;
- (BOOL) wasFolder;


@end
