//
//  VVPageController.h
//  VDMX
//
//  Created by David Lublin on 8/9/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>
#import "VVPage.h"
@class VVPage;
#import "VVFile.h"
@class VVFile;




@interface VVPageController : NSObject <VVSnapshotProtocol> {
	id						appController;

	NSMutableArray			*pages;
	pthread_rwlock_t			pagesLock;
}
- (id) initWithAppController:(id)newController;
//	page management
- (void) addBlankPage;
- (void) addPageFromDirectory:(NSString *)path;
- (void) addPageFromFolderSnapshot:(NSDictionary *)snap;
- (void) insertPage:(VVPage *)newPage atIndex:(int)index;
- (void) removeAllPages;
- (void) removePageAtIndex:(int)removedIndex;
- (void) removePagesAtIndexes:(NSIndexSet *)removeUs;
- (void) copyPagesAtIndexes:(NSIndexSet *)oldIndexes to:(int)newIndex;
- (void) movePagesAtIndexes:(NSIndexSet *)oldIndexes to:(int)newIndex;
- (void) movePageAtIndex:(int)oldIndex to:(int)newIndex;
- (VVPage *) firstPage;
//	file managerment
- (void) addObjects:(NSArray *)objects toPage:(VVPage *)destPage atIndex:(int)index;
- (void) loadFilesFromDirectory:(NSString *)path toPage:(VVPage *)destPage atIndex:(int)index; 
- (BOOL) recordVideoInputNamed:(NSString *)newName toPageWithId:(long)destPageId atIndex:(int)index;
- (void) copyFilesWithIds:(NSArray *)uniqueIdArray toPage:(VVPage *)destPage atIndex:(int)index;
- (void) moveFilesWithIds:(NSArray *)uniqueIdArray toPage:(VVPage *)destPage atIndex:(int)index andReplaceWithBlankSpaces:(BOOL)n;
- (void) addTapNamed:(NSString *)tapName toPageWithId:(long)destPageId atIndex:(int)index;
- (void) addBlankTextFileToPageWithId:(long)destPageId atIndex:(int)index;
- (void) addNewURLFileToPageWithId:(long)destPageId atIndex:(int)index;
- (void) deleteFilesWithIds:(NSArray *)objectIds andReplaceWithBlankSpaces:(BOOL)n;
- (void) closeGapAtIndex:(int)index onPageWithId:(long)pageId;
- (void) closeAllGapsOnPageWithId:(long)pageId;
- (int) totalFileCount;
//- (void) addFiles:(NSArray *)fileArray toPage:(VVPage *) atIndex:(int)index;
//	seaching
- (VVFile *) fileAtIndex:(int)index onPage:(VVPage *)page;
- (VVFile *) lockedFileForUniqueId:(long)findMe;
- (VVFile *) fileForUniqueId:(long)findMe;
- (VVPage *) lockedPageForUniqueId:(long)findMe;
- (VVPage *) pageForUniqueId:(long)findMe;
//	key value
- (NSMutableArray *)pages;
//	locking
- (void) rdlock;
- (void) wrlock;
- (void) unlock;
@end
