//
//  VVQCGLAttrPubContext.h
//  VDMX
//
//  Created by bagheera on 7/4/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import <VVEssentials/VVEssentials.h>
#import "VVQCGLContext.h"
#import "QCCIUIObjects.h"



@interface VVQCGLAttrPubContext : VVQCGLContext <VVSnapshotProtocol> {
	id					attributeLoader;
	float				lastNextState;
	float				lastPrevState;
	float				lastBPM;
	
	id					attributePublisher;
	pthread_rwlock_t	renderLock;
	
	id					dataSourceController;
	id					masterClock;
	NSString			*publisherCatName;
}


+ (id) createWithPath:(NSString *)p textureCache:(CVOpenGLTextureCacheRef)tc andContext:(NSOpenGLContext *)c sized:(NSSize)s;
+ (id) createWithPath:(NSString *)p textureCache:(CVOpenGLTextureCacheRef)tc andContext:(NSOpenGLContext *)c sized:(NSSize)s publishOutputs:(BOOL)o;
- (id) initWithPath:(NSString *)p textureCache:(CVOpenGLTextureCacheRef)tc andContext:(NSOpenGLContext *)c sized:(NSSize)s;
- (id) initWithPath:(NSString *)p textureCache:(CVOpenGLTextureCacheRef)tc andContext:(NSOpenGLContext *)c sized:(NSSize)s publishOutputs:(BOOL)o;

- (BOOL) hasAttributes;
- (void) finishDraw;

- (NSMutableDictionary *) createSnapshot;
- (void) loadSnapshot:(NSDictionary *)snap;
- (void) deprecatedLoadSnapshot:(NSDictionary *)snap;

//	this method exists so subclasses of me can make a different-class attribute loader quickly and easily without writing extra code
- (id) createAttributeLoader;
- (id) createAttributePublisher;

- (void) setDataSourceController:(id)n;	//	MUST BE CALLED- attribute loader has to know where the DSC is
- (void) setMasterClock:(id)n;	//	MUST BE CALLED- attribute loader has to know where the clock is
- (void) setPublisherCatName:(NSString *)n;	//	MUST BE CALLED- attribute publisher has to know what name to publish stuff as

//	i'm the attribute publisher's delegate- these are the delegate methods it needs me to support
- (NSSize) renderSize;
- (void) unlock;
- (void) rdlock;
- (void) wrlock;

- (NSMutableDictionary *) createSnapshot;
- (void) loadSnapshot:(NSDictionary *)d;

- (void) useFile:(NSString *)p resetTimer:(BOOL)t;
- (void) removeAllExistingElements;
- (void) removeAllPublishedSources;

- (void) renderWithFallbackImage:(CIImage *)i;
- (void) renderWithFallbackTexture:(CVOpenGLTextureRef)t;

- (NSMutableDictionary *) currentSnapshotDict;
//- (void) setCurrentSnapshotDict:(NSMutableDictionary *) writeToMe;

- (id) attributeLoader;
- (void) setLiveUpdating:(BOOL)n;
- (void) setParentScrollView:(id)n;
- (id) attributePublisher;


@end
void PixelBufferReleaseCallback(void *releaseRefCon, const void *baseAddress);