//
//  VVQTFile.h
//  VDMX
//
//  Created by David Lublin on 3/27/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CoreVideo/CoreVideo.h>
//#import <VVEssentials/VVEssentials.h>
//#import "CompositorGLView.h"
#import "VVFile.h"
//@class VVFile;
#import "VVWarpMarker.h"
//@class VVWarpMarker;
#import "VVQTMovie.h"
//@class VVQTMovie;
#import "TheApplication.h"
#import "VVFileLoader.h"

@interface VVQTFile : VVFile {
	QTVisualContextRef		visualContext;
	VVQTMovie				*movieFile;
	NSMutableArray			*warpMarkers;
	BOOL					idleCheck;
	BOOL					stillFlag;
	NSString				*recSourceName;
	
	BOOL					movieIsWarped;
	
	QTDataReference		*dataReference;
}

//	init / create
//+ (id) createWithParent:(VVFolder *)newParent andName:(NSString *)newName andCompositor:(id)newCompositor;
//+ (id) createWithPath:(NSString *)newPath andName:(NSString *)newName andCompositor:(id)newCompositor;
+ (id) createWithCompositor:(id)newCompsitor;
+ (id) createQTWithPath:(NSString *)newPath andName:(NSString *)newName andQTMovie:(VVQTMovie *)newMovie andCompositor:(id)newCompositor;
+ (id) createFromRecordingSource:(NSString *)sourceName andCompositor:(id)newCompositor;

//- (id) initWithParent:(VVFolder *)newParent andName:(NSString *)newName andCompositor:(id)newCompositor;
//- (id) initWithPath:(NSString *)newPath andName:(NSString *)newName andQTFlag:(BOOL)newFlag andCompositor:(id)newCompositor;
- (id) initWithCompositor:(id)newCompsitor;
- (id) initQTWithPath:(NSString *)newPath andName:(NSString *)newName andQTMovie:(VVQTMovie *)newMovie andCompositor:(id)newCompositor;
- (id) initFromRecordingSource:(NSString *)sourceName andCompositor:(id)newCompositor;
- (void) recordingDidStop:(NSNotification *)note;
- (void) recordingDidStopMainThread:(NSDictionary *)tempDict;

- (void) initWithQTMovie:(VVQTMovie *) newMovie;
- (void) threadedVisualContextInit;
- (void) prepareForTriggerOnMainThread;
- (void) preRollOnMainThread;
- (void) unPreRollOnMainThread;
//	snapshot
- (NSMutableDictionary *) convertMoviePropsToDict;
- (void) convertDictToMovieProps:(NSMutableDictionary *)dict;
- (BOOL) loadFromSnapshot:(NSMutableDictionary *)snap withFullPath:(NSString *)newPath andCompositor:(id)comp;
//	locking / tasking
//- (BOOL) movieShouldTask:(id)movie;
- (void) setIdleCheck:(BOOL)newValue;
//	warp marker stuff
- (void) addWarpMarkerAtWarpedTime:(QTTime) newMarkerTime;
- (void) addWarpMarkerAtTime:(QTTime)newOriginalTime;
- (void) deleteWarpMarker:(VVWarpMarker *)removeMe;
- (void) deleteWarpMarkerWithOriginalTime:(QTTime)originalTime;
- (void) warpMarkerMoved:(VVWarpMarker *)movedMarker;
- (void) createUnwarpedMovieFile;
- (void) createWarpedMovieFile;
- (NSMutableArray *) warpMarkers;
//	ram load stuff
- (void) setRamloadRange:(QTTimeRange)newRange;
- (void) loadMovieIntoRamThread:(NSValue *)loadRangeValue;
- (void) removeMovieFromRamThread:(NSValue *)removeRangeValue;
//	key value
- (VVQTMovie *) movieFile;
- (NSMutableArray *) warpMarkers;
- (QTVisualContextRef) visualContext;
- (NSString *) recSourceName;
- (BOOL) stillFlag;
- (BOOL) movieIsWarped;
- (BOOL) isMovieCached;
- (QTDataReference *) dataReference;
@end
