//
//  VVStringParser.h
//  VDMX
//
//  Created by David Lublin on 4/25/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <pthread.h>

//	internal parsing modes
#define VVCharacterParseMode		0
#define VVWordParseMode				1
#define VVSentenceParseMode			2	
#define VVLineParseMode				3
#define VVParagraphParseMode		4

//	loop-modes
#define VVPlayOnceMode				0
#define VVLoopMode					1
#define VVPalindromicLoopMode		2

@interface VVStringParser : NSObject {
	//int				loopMode;
	int				parseMode;			//	which parse mode I'm using
	int				loopMode;			//	once, loop, palindromic loop
	BOOL			playingFwd;
	
	NSString		*originalString;	//	the string that I'm parsing
	NSString		*currentString;		//	the current output string
	NSRange			currentRange;		//	the range that my current string is within the entire string
	
	pthread_rwlock_t	rwlock;
}

//	parsing methods
- (void) parseBy:(int)count;
//	by word
- (NSRange) findPrevWord:(int)start;
- (NSRange) findNextWord:(int)start;
- (NSRange) findWordAround:(int)start;
- (NSRange) findWordWithPaddingAround:(int)start;
//	by sentence
- (NSRange) findPrevSentence:(int)start;
- (NSRange) findNextSentence:(int)start;
- (NSRange) findSentenceAround:(int)start;
//	by line breaks
- (NSRange) findPrevLine:(int)start;
- (NSRange) findNextLine:(int)start;
- (NSRange) findLineAround:(int)start;
//	by paragraph
- (NSRange) findParagraphAround:(int)start;

//	key value
- (void) setParseMode:(int)theMode;
- (int) parseMode;
- (void) setLoopMode:(int)theMode;
- (int) loopMode;
- (void) setCurrentRange:(NSRange)theRange;
- (NSRange) currentRange;
- (void) setOriginalString:(NSString *)theString;
- (NSString *) originalString;
- (void) setCurrentString:(NSString *)theString;
- (NSString *) currentString;

//	locking
- (void) rdlock;
- (void) wrlock;
- (void) unlock;
@end
