//
//  VVStringTexture.h
//  VDMX
//
//  Created by bagheera on 5/23/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/CGLMacro.h>


@interface VVStringTexture : NSObject {
	CGLContextObj			destContextObj;	//	the CGLContextObj where my texture is stored
	BOOL					textureExists;
	BOOL					textureNeedsDeletion;
	GLuint					texName;
	NSSize					generatedTexSize;	//	only set when 'texName' is created!
	BOOL					deleted;
	
	NSAttributedString		*attrString;
	NSColor					*boxColor;
	NSColor					*frameColor;
}


+ (id) createWithAttrString:(NSAttributedString *)s inContext:(CGLContextObj)con boxColor:(NSColor *)bc frameColor:(NSColor *)fc;
- (id) initWithAttrString:(NSAttributedString *)s inContext:(CGLContextObj)con boxColor:(NSColor *)bc frameColor:(NSColor *)fc;

- (void) drawAtPoint:(NSPoint)p;

- (void) genTexture;
- (void) deleteTexture;
- (NSImage *) generateImage;
- (NSBitmapImageRep *) generateBitmapImage;

- (NSSize) generatedTexSize;


@end
