//
//  VVTextUI.h
//  VDMX
//
//  Created by David Lublin on 4/24/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVButton.h"
//@class VVButton;
//#import <VVEssentials/VVEssentials.h>
#import "VVNSPopUpButton.h"
//@class VVNSPopUpButton;
#import "VVStringParser.h"
@class VVStringParser;
//#import "VVTextFile.h"
//@class VVTextFile;
#import "VVNSTextView.h"
@class VVNSTextView;
#import "VVTextFile.h"




@protocol TextUIDelegateProtocol
	- (void) textUIChanged:(id)sender;		//	these may be identical; i dunno, i didn't write 'em
	- (void) VVTextUIChanged:(id)sender;
@end





@interface VVTextUI : NSBox <VVSnapshotProtocol> {
	//	communications
	id							delegate;
	id							target;
	SEL							action;

	NSString					*key;

	//	UI items
	NSScrollView				*textScrollView;
	VVNSTextView				*textView;
	VVNSPopUpButton				*parseModePopUpButton;
	VVNSPopUpButton				*loopModePopUpButton;
	VVButton					*parseBackButton;
	VVButton					*parseFwdButton;
	
	//	internal
	VVStringParser				*stringParser;
	NSRange						onDeckRange;
	BOOL						textOnDeckFlag;
	
	BOOL						deleted;
	
	BOOL						isBeingEdited;
	
	NSRect						lastRenderedFrame;
	
	BOOL						needsTextHighlightUpdate;
}

- (NSString *) description;
- (void) prepareToBeDeleted;

//	IBActions, notifications, etc
- (void)textDidBeginEditing:(NSNotification *)note;
- (void) textDidEndEditing:(NSNotification *)note;
- (IBAction) parseBackButtonUsed:(id)sender;
- (IBAction) parseFwdButtonUsed:(id)sender;
- (IBAction) parseModePopUpButtonUsed:(id)sender;
- (IBAction) loopModePopUpButtonUsed:(id)sender;
- (void) scrollToCurrentLine;
//	various
- (void) updateTextHighlights;
- (void) bang;
- (void) repositionElements;
//	setting the string
- (void) loadFile:(id)loadMe;
//	key-value
- (NSString *) key;
- (void) setKey:(NSString *) newKey;
- (VVStringParser *) stringParser;
- (id) delegate;
- (void) setDelegate:(id)newDelegate;
- (void) setTarget:(id)newTarget;
- (void) setAction:(SEL)newAction;
- (VVButton *) parseBackButton;
- (VVButton *) parseFwdButton;
- (NSString *) currentString;

//	I'm the delegate for a bunch of sliders and buttons..
- (void) VVSliderInterestingPointsChanged:(id)sender;
- (void) VVSliderSyncFlagChanged:(id)sender;
- (void) VVSliderBehavFlagChanged:(id)sender;
- (void) VVSliderMaxEnvChanged:(id)sender;
- (void) VVSliderMinEnvChanged:(id)sender;
- (void) VVButtonSyncFlagChanged:(id)sender;
- (void) VVButtonThreshValChanged:(id)sender;
- (void) paramSnapUpdated:(id)sender;

- (void) setColorsFromWindowProps;
- (void) redrawNotification:(NSNotification *)note;

@end
