//
//  VVURLFile.h
//  VDMX
//
//  Created by David Lublin on 3/6/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

//	loads in files of type .webloc or .url

#import <Cocoa/Cocoa.h>
//#import <VVEssentials/VVEssentials.h>
#import "VVFile.h"
//#import "WebKit/WebArchive.h"
#import <WebKit/WebKit.h>
#import "TheApplication.h"



@interface VVURLFile : VVFile {
	NSString		*urlString;			//	the url string (if applicable)
	WebArchive		*webArchive;		//	the web archive (if applicable)
	
	BOOL			readOnly;			//	whether or not the file should change its state based on what happens on a layer
}
+ (BOOL) isURLFile:(NSString *)path;

//	when loading as a file from disk, use this method which will figure out which type of init method to use
+ (id) createWithCompositor:(id)newCompositor andFilePath:(NSString *)path;
- (id) initWithCompositor:(id)newCompositor andFilePath:(NSString *)path;

//	call this method to create a new file that uses a web archive
+ (id) createWithCompositor:(id)newCompositor andWebArchiveData:(NSData *)n andName:(NSString *)nameString;
- (id) initWithCompositor:(id)newCompositor andWebArchiveData:(NSData *)n andName:(NSString *)nameString;

//	this method inits a new url file that will simply load a url when it is triggered
//	it could be created from within VDMX or maybe some other method
+ (id) createWithCompositor:(id)newCompositor andURLString:(NSString *)url;
- (id) initWithCompositor:(id)newCompositor andURLString:(NSString *)url;

//	this method inits a new url file with a url that is embeded in the resource fork of a .webloc file
+ (id) createWithCompositor:(id)newCompositor andWebloc:(NSString *)weblocPath;
- (id) initWithCompositor:(id)newCompositor andWebloc:(NSString *)weblocPath;

//	snapshot stuff
- (NSMutableDictionary *) createSnapshot;
- (BOOL) loadFromSnapshot:(NSMutableDictionary *)snap withCompositor:(id)comp;
- (BOOL) loadFromSnapshot:(NSMutableDictionary *)snap withFullPath:(NSString *)newPath andCompositor:(id)comp;

- (NSMutableDictionary *) convertMoviePropsToDict;
- (void) convertDictToMovieProps:(NSMutableDictionary *)dict;

- (void) setDefaults;

- (BOOL) isLocalFile;
- (void) refreshThumbnailNotification:(NSNotification *)note;

//	key value
- (WebArchive *) webArchive;
- (void) setWebArchive:(WebArchive *)n;
- (NSString *) urlString;
- (void) setUrlString:(NSString *)n;
@end
