//
//  WetDryContext.h
//  VDMX
//
//  Created by bagheera on 2/13/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import <VVEssentials/VVEssentials.h>
#import "GlobalKeys.h"
#import "VVGLContext.h"
#import "VVCIGLContext.h"
#import "VVQCGLContext.h"
#import "VVGL2LayerContext.h"




@interface WetDryContext : NSObject {
	float						wetDryValue;
	CVOpenGLTextureRef			backTextureRef;			//	NOT RETAINED
	CVOpenGLTextureRef			frontTextureRef;		//	NOT RETAINED
	
	int							contentsRenderingMode;	//	0 = CI/QC, 1 = OpenGL
	int							compRenderingMode;		//	0 = CI, 1 = QC
	VVGLContext					*compContext;			//	either a VVGL2LayerContext, a VVCIGLContext, or a VVQCGLContext
	CIFilter					*frontAlphaFilter;		//	if i'm using CI, this is the alpha filter applied to the front texture prior to composition
	CIFilter					*backAlphaFilter;		//	if i'm using CI, this is the alpha filter applied to the back texture prior to composition
	CIFilter					*ciCompFilter;			//	if i'm using CI, this is the comp. filter used to composite front over back
	GLenum						sFactor;
	GLenum						dFactor;
	NSString					*CIFilterName;
	NSString					*QCFilterName;
	
	NSOpenGLContext				*sharedContext;		//	NOT RETAINED- this is the main shared context
	CVOpenGLTextureCacheRef		textureCacheRef;	//	NOT RETAINED- one cache is maintained
	CGColorSpaceRef				colorSpace;
	NSSize						size;
	BOOL						deleted;
}

+ (id) createWithContext:(NSOpenGLContext *)c textureCache:(CVOpenGLTextureCacheRef)tc sized:(NSSize)s;
- (id) initWithContext:(NSOpenGLContext *)c textureCache:(CVOpenGLTextureCacheRef)tc sized:(NSSize)s;

- (NSMutableDictionary *) createSnapshot;
- (void) loadSnapshot:(NSDictionary *)d;

- (void) setBackTextureRef:(CVOpenGLTextureRef)n;
- (void) setFrontTextureRef:(CVOpenGLTextureRef)n;

- (float) wetDryValue;
- (void) setWetDryValue:(float)n;

- (void) useGLCompMode:(int)n;
- (void) useQCCompMode:(NSString *)n;
- (void) useCICompMode:(NSString *)n;
- (void) setContentsRenderingMode:(int)n;
- (void) setCompRenderingMode:(int)n;
- (id) createCompContext;		//	simply makes a new compContext, based on the existing values

- (void) prepareToBeDeleted;
- (void) setSize:(NSSize)n;
- (void) setPBufferRef:(CVOpenGLBufferRef)n;
- (void) render;
- (void) draw;
- (CVOpenGLTextureRef) textureRef;

- (int) contentsRenderingMode;
- (int) compRenderingMode;
- (int) dFactor;
- (NSString *) CIFilterName;
- (NSString *) QCFilterName;


@end
